{*******************************************************************************
      : BASS Spectrum (WinAPI )
        : 30-06-2008
      : 1.0.0.1 Alpha
       : Maksim V
      : http://www.stream-player.narod.ru
   : Copyright (c) 2008 Maksim V

    :
  ----------------
  v.1.0.0.1a [30.06.2008]
   -     .
   -     .
   -     .
   -     .
   -     .
   -   .
   -   Drag&Drop.
  v.1.0.0.0a [29.06.2008]
   -  .

   :     Bass 2.3.0.3

   :        mp3 
      .

        Bass   .
*******************************************************************************}

program Spectrum;

uses
 Windows, Messages, ShellApi, Bass;

{$R Spectrum.res}

const
  RES_DIALOG  = 101;
  ID_SPECTRUM = 101;
  ID_PLAYING  = 102;
  ID_STOPPING = 103;

var
  Stream     : HSTREAM;
  hApp       : Integer;
  hdcMem     : HDC;
  RctSpm     : TRect;
  FFT        : Array [0..256] of Single;
  hBmpNew    : THandle;
  hBmpOld    : THandle;
  SpecPS     : TPaintStruct;
  SpecDC     : HDC;
  ThrWndSpec : THandle;
  ThrIdSpec  : Cardinal;
  FileName   : Array [0..MAX_PATH] of Char;

function PlayFile : Boolean;
begin
  Result := FALSE;
  BASS_Stop;
  BASS_Start;
  Stream := BASS_StreamCreateFile(FALSE, PChar(@FileName), 0, 0, BASS_MP3_SETPOS or BASS_STREAM_AUTOFREE);
  BASS_ChannelPlay(Stream, FALSE);
end;

function StopFile : Boolean;
begin
  Result := FALSE;
  BASS_StreamFree(Stream);
  BASS_Stop;
  SendMessage(hApp, WM_SETTEXT, 0, Integer(PChar('Spectrum')));
end;

function OwnerdrawSpectrum : Boolean;
var
  IdxSpm     : Integer;
  hTxtFnt    : HFONT;
  PenNew     : HPEN;
  PenOld     : HPEN;
  BkgModeNew : HBRUSH;
  BkgModeOld : HBRUSH;
begin
  SetThreadPriority(ThrWndSpec, THREAD_PRIORITY_NORMAL);
  while TRUE do
    begin
      GetClientRect(GetDlgItem(hApp, ID_SPECTRUM), RctSpm);

      //      
      FillRect(hdcMem, RctSpm, 0);

      //      
      BkgModeNew := CreateHatchBrush(HS_BDIAGONAL, RGB(0, 255, 0));
      BkgModeOld := SelectObject(hdcMem, BkgModeNew);
      PenNew := CreatePen(PS_DOT, 1, RGB(0, 0, 255));
      SetBkMode(hdcMem, TRANSPARENT);
      PenOld := SelectObject(hdcMem, PenNew);
      //    
      Rectangle(hdcMem, 0, 0, RctSpm.Right - RctSpm.Left, RctSpm.Bottom - RctSpm.Top);
      //      
      SelectObject(hdcMem, PenOld);
      DeleteObject(PenNew);
      SelectObject(hdcMem, BkgModeOld);
      DeleteObject(BkgModeNew);

      //      
      if (BASS_ChannelIsActive(Stream) = BASS_ACTIVE_PLAYING) then
        begin
          BASS_ChannelGetData(Stream, @FFT, BASS_DATA_FFT1024);
          for IdxSpm := 1 to 256 do
            begin
              MoveToEx(hdcMem, IdxSpm, RctSpm.Bottom - RctSpm.Top, nil);
              LineTo(hdcMem, IdxSpm, (RctSpm.Bottom - RctSpm.Top) - Round(fft[IdxSpm] * (RctSpm.Bottom - RctSpm.Top) * IdxSpm));
            end;
        end
      else
        begin
          RctSpm.Top := RctSpm.Top + 14;
          hTxtFnt := CreateFont(13, 0, 0, 0, 800, 0, 0, 0, RUSSIAN_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH, 'Tahoma');
          DrawText(hdcMem, PChar('Spectrum'), - 1, RctSpm, DT_CENTER or DT_VCENTER);
          SelectObject(hdcMem, hTxtFnt);
          DeleteObject(hTxtFnt);
        end;

      //    
      InvalidateRect(hApp, nil, FALSE);

      //     
      Sleep(25);
    end;
  Result := TRUE;
end;

function WMDragDropFiles(hDrop : DWORD) : Boolean;
var
  L        : DWORD;
  K        : DWORD;
  DragFile : PChar;
begin
  GetMem(DragFile, MAX_PATH);
  K := DragQueryFile(hDrop, $FFFFFFFF, nil, 0);
  for L := 0 to K - 1 do
  begin
    DragQueryFile(hDrop, L, DragFile, MAX_PATH);
    lstrcpy(FileName, PChar(DragFile));
    SendMessage(hApp, WM_SETTEXT, 0, Integer(PChar(@FileName)));
  end;
  FreeMem(DragFile);
  Result := TRUE;
end;

function GenDlgProc(hWnd : HWND; uMsg : UINT; wParam, lParam : Integer) : Bool; stdcall;
begin
  Result := FALSE;
  case uMsg of

    WM_DROPFILES  : WMDragDropFiles(wParam);

    WM_INITDIALOG :
      begin
        hApp := hWnd;
        SendMessage(hApp, WM_SETTEXT, 0, Integer(PChar('Spectrum')));

        if not(BASS_Init(-1, 44100, 0, hApp, nil)) then Exit;

        GetClientRect(hApp, RctSpm);
        hdcMem := CreateCompatibleDC(0);
        hBmpNew := CreateCompatibleBitmap(GetDC(GetDlgItem(hApp, ID_SPECTRUM)), RctSpm.Right - RctSpm.Left, RctSpm.Bottom - RctSpm.Top);
        hBmpOld := SelectObject(hdcMem, hBmpNew);
        DeleteObject(hBmpNew);

        ThrWndSpec := CreateThread(nil, 0, @OwnerdrawSpectrum, nil, 0, ThrIdSpec);
      end;

    WM_ERASEBKGND :
      begin
        GetClientRect(hApp, RctSpm);
        SpecDC := BeginPaint(hApp, SpecPS);
        FillRect(SpecDC, RctSpm, COLOR_BTNFACE + 1);
        EndPaint(hApp, SpecPS);
        Result := TRUE;
      end;

    WM_PAINT :
      begin
        GetClientRect(GetDlgItem(hApp, ID_SPECTRUM), RctSpm);
        SpecDC := BeginPaint(GetDlgItem(hApp, ID_SPECTRUM), SpecPS);
        BitBlt(SpecDC, 0, 0, RctSpm.Right - RctSpm.Left, RctSpm.Bottom - RctSpm.Top, hdcMem, 0, 0, SRCCOPY);
        EndPaint(GetDlgItem(hApp, ID_SPECTRUM), SpecPS);
        Result := FALSE;
      end;

    WM_COMMAND :
      case LoWord(wParam) of
        ID_PLAYING : PlayFile;
        ID_STOPPING : StopFile;
      end;

    WM_DESTROY, WM_CLOSE :
      begin
        Bass_Stop;
        BASS_StreamFree(Stream);
        BASS_Free;
        TerminateThread(ThrWndSpec, 0);
        CloseHandle(ThrWndSpec);
        PostQuitMessage(0);
      end;

  end;
end;

begin
  DialogBox(hInstance, MAKEINTRESOURCE(RES_DIALOG), 0, @GenDlgProc);

end.